Subject: Re: [bug#61265] [PATCH 0/1] Add lint checker for unused module imports.

From: Leo Famulari <[email-masked]>
Date: Sun, 5 Feb 2023 14:09:16 +0100

On Sat, Feb 04, 2023 at 01:42:28AM -0500, Reily Siegel wrote:
> 
> Julien Lepiller <[email-masked]> writes (guix-devel):
> 
> > Many modules seem to use a lot of imports that are actually useless,
> > for instance (gnu packages heads) imports 20 package modules, but
> > only uses 4 of them.
> >
> > Removing these module imports would help a lot with reducing the number
> > of loops. If anyone wants to volunteer a lint checker for that,
> > raise hands :D
> 
> This is a quick and dirty implementation of such a lint checker. It
> compares the symbols used in a module to those provided by its
> dependencies. If there is a dependency for which none of the symbols
> overlap, a warning is reported. A potential downside of this approach is
> that the lint checker cannot distinguish between lexically scoped
> variables and variables which actually reference another module. This
> has two effects:

Nice!

Off-topic, if you are sending a patch series, be sure to follow the
instructions in the manual section Sending a Patch Series:

https://guix.gnu.org/manual/devel/en/html_node/Sending-a-Patch-Series.html

Otherwise, the ticketing system creates a new ticket for each patch,
like here. Don't worry, I've merged the ticket.